unit BasUnit;

interface

uses DesUnit;

  function FromSetToLongint(const Operand:set32):longint;
  function FromLongintToSet(const Operand:longint):set32;
  function FromSetToByte(const Operand:set8):byte;
  function FromByteToSet(const Operand:byte):set8;
  function FromSetToH(const Operand:set4):byte;
  function FromSetToRK(x: set32):RKType;
  function FromLongintToStr(l : longint): string;
  function FromByteToStr(l : Byte): string;
  function FromSetToStr(x: Set32):string;
  procedure Restart;

implementation

function FromSetToLongint(const Operand:set32):longint;
{      }
type
  set32x = set of 0..31;
var
  i: byte;
  x: set32x;
  res: longint absolute x;
begin
  x:=[];
  for i:=1 to 32 do
    if i in Operand then
      x:=x+[32-i];
  FromSetToLongint:=res;
end; { FromSetToLongint }
{ -------------------------------------------------------------- }
function FromLongintToSet(const Operand:longint):set32;
{      }
type
  set32x = set of 0..31;
var
  i: byte;
  x: set32x absolute Operand;
  res: set32;
begin
  res:=[];
  for i:=0 to 31 do
    if i in x then
      res:=res+[32-i];
  FromLongintToSet:=res;
end; { FromLongintToSet }
{ -------------------------------------------------------------- }
function FromSetToByte(const Operand:set8):byte;
{      }
type
  set8x = set of 0..7;
var
  i: byte;
  x: set8x;
  res: byte absolute x;
begin
  x:=[];
  for i:=1 to 8 do
    if i in Operand then
      x:=x+[8-i];
  FromSetToByte:=res;
end; { FromSetToByte }
{ -------------------------------------------------------------- }
function FromByteToSet(const Operand:byte):set8;
{      }
type
  set8x = set of 0..7;
var
  i: byte;
  x: set8x absolute Operand;
  res: set8;
begin
  res:=[];
  for i:=0 to 7 do
    if i in x then
      res:=res+[8-i];
  FromByteToSet:=res;
end; { FromByteToSet }
{ -------------------------------------------------------------- }
function FromSetToH(const Operand:set4):byte;
{      }
type
  set8x = set of 0..7;
var
  i: byte;
  x: set8x;
  res: byte absolute x;
begin
  x:=[];
  for i:=1 to 4 do
    if i in Operand then
      x:=x+[4-i];
  FromSetToH:=res;
end;
{ -------------------------------------------------------------- }
Function FromSetToRK(x: set32):RKType;
var
  i: byte;
begin
  Result.KOP:=[];
  for i:=1 to 4 do
    if i in x then
      include(Result.KOP,i);
  Result.MA:=[];
  for i:=5 to 8 do
    if i in x then
      include(Result.MA,i-4);
  Result.A1:=[];
  for i:=9 to 16 do
    if i in x then
      include(Result.A1,i-8);
  Result.A2:=[];
  for i:=17 to 24 do
    if i in x then
      include(Result.A2,i-16);
  Result.A3:=[];
  for i:=25 to 32 do
    if i in x then
      include(Result.A3,i-24);
end; { FromSetToRK }
{ -------------------------------------------------------------- }
function FromLongintToStr(l : longint): string;
begin
  str(l, Result);
  while Length(Result) < 11 do
    result:=Result+' ';
end; { FromLongintToStr }
{ -------------------------------------------------------------- }
function FromByteToStr(l : Byte): string;
begin
  str(l, Result);
  while Length(Result) < 3 do
    result:=Result+' ';
end; { FromByteToStr }
{ -------------------------------------------------------------- }
function FromSetToStr(x: Set32):string;
var
  i : byte;
begin
  Result:='';
  for i:=1 to 32 do
    begin
      if (i-1) mod 8 = 0 then
        Result:=Result+' ';

      if i=5 then
        Result:=Result+' ';

      if i in x then
        Result:=Result+'1'
      else
        Result:=Result+'0';
    end;
end; { FromSetToStr }
{ -------------------------------------------------------------- }
procedure Restart;
var
  i: byte;
begin
  for i:=0 to MaxAddress do
    Memory[i]:=[];
  R1:=[];
  R2:=[];
  AC:=[];
  RS:=[];
  RA:=0;
  SAK:=0;
  A1isp:=0;
  A2isp:=0;
  A3isp:=0;
  RP:=[];
  RK.KOP:=[];
  RK.MA:=[];
  RK.A1:=[];
  RK.A2:=[];
  RK.A3:=[];
  Prepared:=false;
  CondExec:=false;
end; { Restart }

end.
