unit CmdUnit;

interface

  uses DesUnit,BasUnit, Dialogs;

  function Step:boolean;
  procedure MakeAisp;
  procedure PrepareCmd;

implementation

procedure HaltProc;
begin
  CondExec:=false;
  Prepared:=false;
end;

procedure Add;
var
  op1,op2: longint;
  res: real;
  tmp: longint;
begin
  op1:=FromSetToLongint(R1);
  op2:=FromSetToLongint(R2);
  res:=op1+op2;

  AC:=FromLongintToSet(op1+op2);
  tmp:=FromSetToLongint(AC);

  if tmp = 0 then           {  Z }
    include(RP,2)
  else
    exclude(Rp,2);

  if tmp < 0 then           {  S }
    include(RP,1);
  if tmp > 0 then
    exclude(RP,1);

  if (res<-MaxNumber-1) or (res>MaxNumber) then
    include(RP,3)
  else
    exclude(RP,3);  
end; { Add }
{ -------------------------------------------------------------- }
procedure Sub;
var
  op1,op2: longint;
  res: real;
  tmp: longint;
begin
  op1:=FromSetToLongint(R1);
  op2:=FromSetToLongint(R2);
  res:=op1-op2;

  AC:=FromLongintToSet(op1-op2);
  tmp:=FromSetToLongint(AC);

  if tmp = 0 then           {  Z }
    include(RP,2)
  else
    exclude(Rp,2);

  if tmp < 0 then           {  S }
    include(RP,1);
  if tmp > 0 then
    exclude(RP,1);

  if (res<-MaxNumber-1) or (res>MaxNumber) then
    include(RP,3)
  else
    exclude(RP,3);
end; { Sub }
{ -------------------------------------------------------------- }
procedure Mul;
var
  op1,op2: longint;
  res: real;
  tmp: longint;
begin
  op1:=FromSetToLongint(R1);
  op2:=FromSetToLongint(R2);
  res:=op1*op2;

  AC:=FromLongintToSet(op1*op2);
  tmp:=FromSetToLongint(AC);

  if tmp = 0 then           {  Z }
    include(RP,2)
  else
    exclude(Rp,2);

  if tmp < 0 then           {  S }
    include(RP,1);
  if tmp > 0 then
    exclude(RP,1);

  if (res<-MaxNumber-1) or (res>MaxNumber) then
    include(RP,3)
  else
    exclude(RP,3);
end; { Mul }
{ -------------------------------------------------------------- }
procedure Divide;
var
  op1,op2: longint;
  res: longint;
begin
  op1:=FromSetToLongint(R1);
  op2:=FromSetToLongint(R2);
  if op2 = 0 then
    begin
      CondExec:=false;
      ErrorStr:='     '+FromByteToStr(SAK);
      Showmessage(ErrorStr);
      Prepared:=false;
      exit
    end;
  res:=op1 div op2;

  AC:=FromLongintToSet(res);

  if res = 0 then           {  Z }
    include(RP,2)
  else
    exclude(Rp,2);

  if res < 0 then           {  S }
    include(RP,1);
  if res > 0 then
    exclude(RP,1);
end; { Divide }
{ -------------------------------------------------------------- }
procedure Conjunct;
var
  op1,op2,res: longint;
begin
  op1:=FromSetToLongint(R1);
  op2:=FromSetToLongint(R2);

  res:=op1 and op2;
  AC:=FromLongintToSet(res);

  if res = 0 then           {  Z }
    include(RP,2)
  else
    exclude(Rp,2);

  if res < 0 then           {  S }
    include(RP,1);
  if res > 0 then
    exclude(RP,1);
end; { Conjunct }
{ -------------------------------------------------------------- }
procedure Disjunct;
var
  op1,op2,res: longint;
begin
  op1:=FromSetToLongint(R1);
  op2:=FromSetToLongint(R2);

  res:=op1 or op2;
  AC:=FromLongintToSet(res);

  if res = 0 then           {  Z }
    include(RP,2)
  else
    exclude(Rp,2);

  if res < 0 then           {  S }
    include(RP,1);
  if res > 0 then
    exclude(RP,1);
end; { Disjunct }
{ -------------------------------------------------------------- }
procedure NotProc;
var
  op1,res: longint;
begin
  op1:=FromSetToLongint(R1);
  res:= not op1;
  AC:=FromLongIntToSet(res);

  if res = 0 then           {  Z }
    include(RP,2)
  else
    exclude(Rp,2);

  if res < 0 then           {  S }
    include(RP,1);
  if res > 0 then
    exclude(RP,1);
end; { NotProc }
{ -------------------------------------------------------------- }
procedure SubModul;
var
  op1,op2: longint;
  res: real;
  tmp: longint;
begin
  op1:=Abs(FromSetToLongint(R1));
  op2:=Abs(FromSetToLongint(R2));
  res:=op1-op2;

  AC:=FromLongintToSet(op1-op2);
  tmp:=FromSetToLongint(AC);

  if tmp = 0 then           {  Z }
    include(RP,2)
  else
    exclude(Rp,2);

  if tmp < 0 then           {  S }
    include(RP,1);
  if tmp > 0 then
    exclude(RP,1);

  if (res<-MaxNumber-1) or (res>MaxNumber) then
    include(RP,3)
  else
    exclude(RP,3);
end; { SubModul }
{ ------------------------------------------------------------- }
procedure AddModul2;
var
  op1,op2,res: longint;
begin
  op1:=FromSetToLongint(R1);
  op2:=FromSetToLongint(R2);

  res:=op1 xor op2;
  AC:=FromLongintToSet(res);

  if res = 0 then           {  Z }
    include(RP,2)
  else
    exclude(Rp,2);

  if res < 0 then           {  S }
    include(RP,1);
  if res > 0 then
    exclude(RP,1);
end; { AddModul2 }
{ -------------------------------------------------------------- }
procedure ShrLogical;
var
  op1,op2,res: longint;
begin
  op1:=FromSetToLongint(R1);
  op2:=FromSetToByte(RK.A2);

  res:= op1 shr op2;
  AC:=FromLongintToSet(res);

  if res = 0 then           {  Z }
    include(RP,2)
  else
    exclude(Rp,2);

  if res < 0 then           {  S }
    include(RP,1);
  if res > 0 then
    exclude(RP,1);  
end; { ShrLogical }
{ -------------------------------------------------------------- }
procedure ToSubRoutine;
begin
  RS:=FromLongintToSet(SAK);
  RA:=FromSetToByte(RK.A3);
  Memory[RA]:=RS;

  SAK:=FromSetToByte(RK.A1);
  Dec(SAK);
end; { ToSubRoutine }
{ --------------------------------------------------------------- }
procedure JumpUS;
begin
  if 1 in RP then  // S=1
    begin
      RA:=FromSetToByte(RK.A1);
      SAK:=RA;
      Dec(SAK);
    end;
  if 2 in RP then  // Z=1
    begin
      RA:=FromSetToByte(RK.A2);
      SAK:=RA;
      Dec(SAK);
    end;
  if (not (1 in RP)) and (not (2 in RP)) then
    begin
      RA:=FromSetToByte(RK.A3);
      SAK:=RA;
      Dec(SAK);
    end;
end; { JumpUS }
{ -------------------------------------------------------------- }
procedure Jump;
begin
  RA:=FromSetToByte(RK.A1);

  SAK:=RA;
  Dec(SAK);
end; { Jump }
{ -------------------------------------------------------------- }
Procedure Loop;
var
  i : byte;
  op1,op2: set32;
begin
  RA:=FromSetToH(RK.MA);
  RS:=Memory[RA];
  op1:=RS;

  RA:=FromSetToByte(RK.A1);
  RS:=Memory[RA];
  op2:=RS;

  R1:=[];               { 1..8 }
  for i:=1 to 8 do
    if i in op1 then
      Include(R1,i+24);
  R2:=[];
  for i:=25 to 32 do
    include(R2,i);
  Add;
  for i:=25 to 32 do
    if i in AC then
      Include(op1,i-24)
    else
      Exclude(op1,i-24);  

  R1:=op1;              { 25..32 }
  R2:=[];
  for i:=25 to 32 do
    if i in op2 then
      Include(R2,i);
  Add;
  for i:=25 to 32 do
    if i in AC then
      include(op1,i)
    else
      exclude(op1,i);

  R1:=op1;              { 17..24 }
  R2:=[];
  for i:=17 to 24 do
    if i in op2 then
      Include(R2,i);
  Add;
  for i:=17 to 24 do
    if i in AC then
      include(op1,i)
    else
      exclude(op1,i);

  R1:=op1;              { 9..16 }
  R2:=[];
  for i:=9 to 16 do
    if i in op2 then
      Include(R2,i);
  Add;
  for i:=9 to 16 do
    if i in AC then
      include(op1,i)
    else
      exclude(op1,i);


  R1:=op1;
  R2:=[];
  Add;

  RA:=fromSetToH(RK.MA);
  RS:=AC;
  Memory[RA]:=RS;

  if 1 in AC then
    begin
      include(RP,4);
      SAK:=FromSetToByte(RK.A3);
      Dec(SAK)
    end
  else
    begin
      exclude(RP,4);
      SAK:=FromSetToByte(RK.A2);
      Dec(SAK)
    end;

end; { Loop }
{ -------------------------------------------------------------- }
procedure FromSubRoutine;
begin
  RA:=FromSetToByte(RK.A3);
  RS:=Memory[RA];
  SAK:=FromSetToLongint(RS);
end; { FromSubRoutine }

{ -------------------------------------------------------------- }
{ ----------------- * * * * * * * * * * * * -------------------- }
{ -------------------------------------------------------------- }
procedure MakeAisp;
{      }
var
  op2 : set32;
  i : byte;
begin
  if RK.MA <> [] then
    begin
      RA:= fromSetToH(RK.MA);
      RS:=Memory[RA];
      R1:=RS;
      { A1 }
      op2:=[];
      for i:=1 to 8 do
        if i in RK.A1 then
          include(op2,i+8);
      R2:=op2;
      Add;
      RK.A1:=[];
      for i:=1 to 8 do
        if (i+8) in AC then
          include(RK.A1,i);
      { A2 }
      op2:=[];
      for i:=1 to 8 do
        if i in RK.A2 then
          include(op2,i+16);
      R2:=op2;
      Add;
      RK.A2:=[];
      for i:=1 to 8 do
        if (i+16) in AC then
          include(RK.A2,i);
      { A3 }
      op2:=[];
      for i:=1 to 8 do
        if i in RK.A3 then
          include(op2,i+24);
      R2:=op2;
      Add;
      RK.A3:=[];
      for i:=1 to 8 do
        if (i+24) in AC then
          include(RK.A3,i);
    end;
end; { MakeAisp }
{ -------------------------------------------------------------- }
procedure PrepareCmd;
begin
  RA:=FromSetToByte(RK.A1);
  RS:=Memory[RA];
  R1:=RS;

  RA:=FromSetToByte(RK.A2);
  RS:=Memory[RA];
  R2:=RS;
end; { PrepareCmd }
{ -------------------------------------------------------------- }
procedure RunCmd(Index: byte);
begin
  if Index <> 14 then //        
    MakeAisp;
  PrepareCmd;
  case Index of
    0: HaltProc;
    1: Add;
    2: Sub;
    3: Mul;
    4: Divide;
    5: Conjunct;           // And
    6: Disjunct;           // Or
    7: NotProc;            // Not
    8: SubModul;           //
    9: AddModul2;          // Xor
    10: ShrLogical;
    11: ToSubRoutine;
    12: JumpUS;
    13: Jump;
    14: Loop;
    15: FromSubRoutine;
  end;
  if (Index > 0) and (Index < 11) then
    begin
      RS:=AC;
      RA:=FromSetToByte(RK.A3);
      Memory[RA]:=RS;
    end;  
end; { RunCmd }
{ -------------------------------------------------------------- }
function step: boolean;
var
  cmd: byte;
begin
  Result:=False;
  if CondExec and prepared then
    begin
      Result:=true;
      RA:=SAK;
      RS:=Memory[RA];
      RK:=FromSetToRK(RS);
      cmd:=FromSetToH(RK.KOP);
      RunCmd(cmd);
      if not CondExec then
        Result:=false
      else
        inc(SAK);  
    end;
end; { step }
{ -------------------------------------------------------------- }

end.
