unit InpUnit;

interface

uses DesUnit, BasUnit, Dialogs;


  function InpStrToSet(st : string11) : set32;
  procedure FormatStr(var s : string);
  procedure LoadTest;

implementation

const
  Decemial = '0123456789';
  Dig = '01234567';
  Bin : array[1..8] of string3 =
    ('000','001','010','011','100','101','110','111');

var
  InpErr: boolean;

function InpStrToSet(st : string11) : set32;
{        }
var
  s : string32;
  i : byte;
begin
  Result:=[];

  s:=Bin[Pos(st[1],Dig)];
  Delete(s,1,1);

  for i:= 2 to 11 do
    s:= s + Bin[Pos(st[i],Dig)];

  for i:=1 to 32 do
    if s[i]='1' then
      Result:=Result+[i];

end; { InpStrToSet }
{ -------------------------------------------------------------- }
procedure FormatStr(var s : string);
var
  k : byte;
  s1:string;
begin
  s1:=s;

  k:=pos(';',s1);
  if k<>0 then
    delete(s1,k,Length(s)-k+1);

  while (Length(s1)<>0) and (pos(s1[1],Decemial) = 0) do
    delete(s1,1,1);

  while (Length(s1)<>0) and (pos(s1[Length(s1)],Decemial) = 0) do
    delete(s1,Length(s1),1);

  if length(s1) > 11 then
    begin
      ErrorStr:='      .'+#10+#13+
                '  !';
      InpErr:=true;
      Showmessage(ErrorStr);
      exit;
    end;
  s:=s1;
end; { FormatStr }
{ -------------------------------------------------------------- }
procedure LoadTest;
const
  NfMax = 200;  {  -     }
type
  FileStringAr = array[1..NfMax] of string;
var
  s    : string;
  code : integer;
  k    : byte;
  Sf: FileStringAr;
  nf : byte;
  i,j : byte;
begin
  Restart; {     }
  nf:=0;
  InpErr:=false;

  while not EOF(TestFile) do
    begin
      inc(nf);
      ReadLn(TestFile,s);
      FormatStr(s); {    .. }
      Sf[nf]:=s
    end;

  CloseFile(TestFile);

  i:=1;
  While i <= nf do
    begin
      if Length(Sf[i]) = 0 then
        begin
          for j:=i to nf-1 do
            Sf[j]:=sf[j+1];
          Dec(nf)
        end
      else
        inc(i)
    end;

  if (nf=0) or (nf > NfMax) then
    begin
      ErrorStr:='     !';
      InpErr:=true;
      Showmessage(ErrorStr);
      exit
    end;

  val(Sf[1], k, code);
  if code <> 0 then
    begin
      ErrorStr:='    '+#10+#13+Sf[1];
      InpErr:=true;
      Showmessage(ErrorStr);
      exit;
    end;

  val(Sf[2], SAK, code);
  if (code <> 0) or (SAK < 16) then
    begin
      ErrorStr:='  SAK,    16';
      InpErr:=true;
      Showmessage(ErrorStr);
      exit;
    end;

  if (k+nf-3) > 255 then
    begin
      ErrorStr:='   !';
      InpErr:=true;
      Showmessage(ErrorStr);
      exit
    end;

  if not InpErr then
    begin
      for i:=3 to nf do
        begin
          Memory[k]:= InpStrToSet(Sf[i]);
          inc(k);
        end;
      Prepared:=true;
    end
  else
    Restart;

end; { LoadTest }

end.
