unit WinUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,
  DesUnit,BasUnit,InpUnit, CmdUnit, Menus, ComCtrls;

type
  TForm1 = class(TForm)
    MemListBox: TListBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    MainMenu1: TMainMenu;
    e1: TMenuItem;
    est11: TMenuItem;
    est21: TMenuItem;
    est31: TMenuItem;
    N1: TMenuItem;
    Other1: TMenuItem;
    Run1: TMenuItem;
    Step1: TMenuItem;
    Reset1: TMenuItem;
    Exit1: TMenuItem;
    StatusBar1: TStatusBar;
    GroupBox1: TGroupBox;
    Btn_loadTst1: TButton;
    Btn_loadTst2: TButton;
    Btn_loadTst3: TButton;
    Btn_loadTstFrom: TButton;
    Btn_Run: TButton;
    Btn_Halt: TButton;
    GroupBox2: TGroupBox;
    Edit_Trace: TEdit;
    Btn_Step: TButton;
    Btn_Exit: TButton;
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    RegListBox: TListBox;
    procedure load(s: string);
    procedure RedrawMem;
    procedure RedrawStatus;
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Btn_ExitClick(Sender: TObject);
    procedure Btn_loadTst1Click(Sender: TObject);
    procedure Btn_RunClick(Sender: TObject);
    procedure Btn_StepClick(Sender: TObject);
    procedure Edit_TraceKeyPress(Sender: TObject; var Key: Char);
    procedure Btn_HaltClick(Sender: TObject);
    procedure Reset1Click(Sender: TObject);
    procedure Btn_loadTst2Click(Sender: TObject);
    procedure Btn_loadTst3Click(Sender: TObject);
    procedure Btn_loadTstFromClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.load(s: string);
begin
  Btn_Run.Enabled:=false;
  Btn_Step.Enabled:=false;
  if not FileExists(s) then
    begin
      Showmessage('  !');
      exit;
    end;
  Assignfile(TestFile,s);
  Reset(TestFile);
  LoadTest;
  if Prepared then
    begin
      StatusBar1.Panels.Items[1].Text:='SAK: '+FromByteToStr(SAK);
      Btn_Run.Enabled:=true;
      Btn_Step.Enabled:=true;
    end;
  RedrawMem;
  RedrawStatus;
end;

{ -------------------------------------------------------------- }
function ShowMem(i: byte): string;
begin
  Result:=FromByteToStr(i)+ ' ' +
          FromLongintToStr(FromSetToLongint(Memory[i])) + ' ' +
          FromSetToStr(Memory[i])+' '+LintToOctal(FromSetToLongint(Memory[i]));
end; { ShowMem }
{ -------------------------------------------------------------- }
procedure TForm1.RedrawMem;
var
  i: byte;
begin
  for i:=0 to MaxAddress do
    MemListBox.Items.Strings[i]:=ShowMem(i);
end;

procedure TForm1.RedrawStatus;
var
  i: byte;
  tmp: RKType;
  cmd: byte;
  oldSAK: byte;
begin
  with Statusbar1.Panels.Items[0] do
    begin
      Text:='RP (SZCE): ';
      for i:=1 to 4 do
        if i in RP then
          Text:=Text+'1'
        else
          Text:=Text+'0';
    end;
  Statusbar1.Panels.Items[1].Text:='SAK: '+inttostr(SAK);
  with Statusbar1.Panels.Items[2] do
    begin
      Text:='State: ';
      if CondExec then
        Text:=Text+'Running'
      else
        if prepared then
          Text:=Text+'Ready'
        else
          Text:=Text+'Stop';
    end;
  tmp:=FromSetToRK(Memory[SAK]);
  with Statusbar1.Panels.Items[3] do
    begin
      Text:='CurCmd: ';
      case FromSetToH(tmp.KOP) of
        0: Text:=Text+ 'Halt';
        1: Text:=Text+ 'Add';
        2: Text:=Text+ 'Sub';
        3: Text:=Text+ 'Mul';
        4: Text:=Text+ 'Div';
        5: Text:=Text+ 'And';
        6: Text:=Text+ 'Or';
        7: Text:=Text+ 'Not';
        8: Text:=Text+ 'Sub Modul';
        9: Text:=Text+ 'Xor';
        10: Text:=Text+'Shr';
        11: Text:=Text+'Call';
        12: Text:=Text+'JmpX';
        13: Text:=Text+'Jmp';
        14: Text:=Text+'Loop';
        15: Text:=Text+'Ret';
      end;
      Text:=Text+' '+IntToStr(FromSetToH(tmp.MA))+','+
              IntToStr(FromSetToByte(tmp.A1))+','+
              IntToStr(FromSetToByte(tmp.A2))+','+
              IntToStr(FromSetToByte(tmp.A3))
    end;
  MemListbox.Selected[SAK]:=true;

  RA:=SAK;
  RS:=Memory[RA];
  RK:=FromSetToRK(RS);
  cmd:=FromSetToH(RK.KOP);
  if cmd <> 14 then //        
    MakeAisp;
  PrepareCmd;
  RegListBox.Clear;
  RegListBox.Items.Add('R1:  '+FromLongintToStr(FromSetToLongint(R1))+FromSetToStr(R1)+
    ' '+LIntToOctal(FromSetToLongint(R1)));
  RegListBox.Items.Add('R2:  '+FromLongintToStr(FromSetToLongint(R2))+FromSetToStr(R2)+
    ' '+LIntToOctal(FromSetToLongint(R2)));

  oldSAK:=SAK;
  if (not condexec) and prepared then
    begin
      CondExec:=true;
      step;
      CondExec:=false;
    end
  else
    step;

  SAK:=oldSAK;

  RegListBox.Items.Add('AC:  '+FromLongintToStr(FromSetToLongint(AC))+FromSetToStr(AC)+
    ' '+lIntToOctal(FromSetToLongint(AC)));
  With StatusBar1.Panels.Items[4] do
    begin
      Text:='A1,A2,A3(isp): ';
      Text:=Text+inttostr(FromSetToByte(RK.A1))+',';
      Text:=Text+inttostr(FromSetToByte(RK.A2))+',';
      Text:=Text+inttostr(FromSetToByte(RK.A3));
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Restart;
  RedrawMem;
  RedrawStatus;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
close
end;

procedure TForm1.Btn_ExitClick(Sender: TObject);
begin
close;
end;

procedure TForm1.Btn_RunClick(Sender: TObject);
begin
  if Prepared then
    begin
      CondExec:=true;
      RedrawStatus;
      Btn_Halt.Enabled:=true;
      Btn_Run.Enabled:=false;
      Btn_Step.Enabled:=False;
      while step do
        application.ProcessMessages;
    end
  else
    exit;  
  Btn_Halt.Enabled:=false;

  RedrawMem;
  RedrawStatus;
  Btn_Run.Enabled:=False;
  Btn_Step.Enabled:=False;
end;

procedure TForm1.Btn_StepClick(Sender: TObject);
var
  i:byte;
begin
  if (not CondExec) and prepared then
    begin
      CondExec:=true;
    end;
  if not condexec then
    begin
      Btn_Run.Enabled:=False;
      Btn_Step.Enabled:=False;
      RedrawStatus;
      RedrawMem;
      exit;
    end;

  for i:=1 to StrToInt(Edit_Trace.text) do
    if not Step then
      begin
        Btn_Run.Enabled:=False;
        Btn_Step.Enabled:=False;
        break;
      end;

  RedrawStatus;
  RedrawMem

end;

procedure TForm1.Edit_TraceKeyPress(Sender: TObject; var Key: Char);
begin
if not (Key in [#8,'0'..'9']) then Key := #0;
end;

procedure TForm1.Btn_HaltClick(Sender: TObject);
begin
  CondExec:=false;
  Prepared:=false;
  RedrawMem;
  RedrawStatus
end;

procedure TForm1.Reset1Click(Sender: TObject);
begin
  Restart;
  RedrawMem;
  RedrawStatus
end;

procedure TForm1.Btn_loadTst1Click(Sender: TObject);
begin
  load('1.tst')
end;

procedure TForm1.Btn_loadTst2Click(Sender: TObject);
begin
  load('2.tst')
end;

procedure TForm1.Btn_loadTst3Click(Sender: TObject);
begin
  load('3.tst')
end;

procedure TForm1.Btn_loadTstFromClick(Sender: TObject);
begin
  if opendialog1.Execute then
    begin
      load(opendialog1.FileName)
    end
  else
    beep;
end;

end.
